&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------

  File: tetris.w

  Description: Tetris Game

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: Mauricio Guerrero - Brasil - Sao Paulo

  Created: 07/Jan/2001

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

DEF VAR wc_obj AS CHAR INITIAL 
"L01C01L01C02L01C03L01C04,L01C01L01C02L02C01L02C02,~
L01C02L01C03L02C01L02C02,L01C01L01C02L02C02L02C03,~
L01C01L01C02L01C03L02C03,L01C01L01C02L01C03L02C01,~
L01C02L02C01L02C02L02C03".
      
DEF VAR wc_cor AS CHAR INITIAL 
  "azul,azule,vermelho,verde,roxo,cinza,marrom".
DEF VAR wi_color AS INT INITIAL 0.   
   
DEF VAR wc_giro AS CHAR EXTENT 7.
DEF VAR wi_giro AS INT INITIAL 1.
DEF VAR wi_cubo AS INT.
DEF VAR myx     AS INT.
DEF VAR myy     AS INT.

ASSIGN wc_giro[1] = 
"L01C00L01C01L01C02L01C03,L01C02L02C02L03C02L04C02"
       wc_giro[2] = 
"L01C01L01C02L02C01L02C02"       
       wc_giro[3] = 
"L01C01L01C02L02C00L02C01,L01C01L02C01L02C02L03C02"       
       wc_giro[4] =
"L01C00L01C01L02C01L02C02,L01C02L02C01L02C02L03C01"       
       wc_giro[5] =
"L01C01L01C02L01C03L02C03,L01C02L02C02L03C01L03C02,~
L02C00L03C00L03C01L03C02,L01C01L01C02L02C01L03C01"       
       wc_giro[6] = 
"L01C01L01C02L01C03L02C01,L01C01L01C02L02C02L03C02,~
L02C03L03C01L03C02L03C03,L01C-1L02C-1L03C-1L03C00"
       wc_giro[7] = 
"L01C01L02C00L02C01L02C02,L01C00L02C00L02C01L03C00,~
L01C01L01C02L01C03L02C02,L01C02L02C01L02C02L03C02". 
   
DEF VAR wi_obj AS INT.   
DEF VAR ll AS LOG.
DEF VAR wi AS INT.
DEF VAR wl_pausa AS LOG INITIAL NO.
DEF VAR wi_killer AS INT.
DEF VAR wl_out AS LOG.

DEF TEMP-TABLE t-obj 
  FIELD tobj   AS WIDGET-HANDLE
  FIELD ttype  AS INT
  FIELD tstate AS CHAR 
  FIELD tx     AS DEC
  FIELD ty     AS DEC
  FIELD ttox   AS DEC
  FIELD ttoy   AS DEC
  FIELD tnomov AS LOG INITIAL NO
  INDEX t-obj1 AS UNIQUE tobj
  INDEX t-obj2 tstate
  INDEX t-obj3 tx 
  INDEX t-obj4 tx DESCENDING
  INDEX t-obj5 ty DESCENDING.

DEF TEMP-TABLE t-pos
  FIELD tx AS DEC
  FIELD ty AS DEC
  FIELD tused AS LOG INITIAL YES
  FIELD tout  AS LOG
  INDEX t-pos1 AS UNIQUE tx ty.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME DEFAULT-FRAME

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS rc-1 bt-pausa bt-novo 
&Scoped-Define DISPLAYED-OBJECTS fi-lines 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Menu Definitions                                                     */
DEFINE SUB-MENU m_Game 
       MENU-ITEM m_New          LABEL "New"           
       RULE
       MENU-ITEM m_Exit         LABEL "Exit"          .

DEFINE SUB-MENU m_Help 
       MENU-ITEM m_About        LABEL "About Tetris"  .

DEFINE MENU MENU-BAR-C-Win MENUBAR
       SUB-MENU  m_Game         LABEL "Game"          
       SUB-MENU  m_Help         LABEL "Help"          .


/* Definitions of handles for OCX Containers                            */
DEFINE VARIABLE CtrlFrame AS WIDGET-HANDLE NO-UNDO.
DEFINE VARIABLE chCtrlFrame AS COMPONENT-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON bt-novo 
     LABEL "New" 
     SIZE 13 BY 1.14.

DEFINE BUTTON bt-pausa 
     LABEL "Pause" 
     SIZE 13 BY 1.14.

DEFINE VARIABLE fi-lines AS INTEGER FORMAT ">>>,>>>,>>9":U INITIAL 0 
     LABEL "Lines" 
     VIEW-AS FILL-IN NATIVE 
     SIZE 13 BY 1 NO-UNDO.

DEFINE RECTANGLE rc-1
     EDGE-PIXELS 1 GRAPHIC-EDGE  
     SIZE 20 BY 9.52
     BGCOLOR 0 .


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     bt-pausa AT ROW 11.48 COL 45
     bt-novo AT ROW 3.14 COL 45
     fi-lines AT ROW 5.29 COL 57 RIGHT-ALIGNED
     rc-1 AT ROW 3.14 COL 7
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 62 BY 12.81.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "Tetris"
         HEIGHT             = 12.81
         WIDTH              = 62
         MAX-HEIGHT         = 12.81
         MAX-WIDTH          = 62
         VIRTUAL-HEIGHT     = 12.81
         VIRTUAL-WIDTH      = 62
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.

ASSIGN {&WINDOW-NAME}:MENUBAR    = MENU MENU-BAR-C-Win:HANDLE.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME


/* ***************  Runtime Attributes and UIB Settings  ************** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
   Custom                                                               */
/* SETTINGS FOR FILL-IN fi-lines IN FRAME DEFAULT-FRAME
   NO-ENABLE ALIGN-R                                                    */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* **********************  Create OCX Containers  ********************** */

&ANALYZE-SUSPEND _CREATE-DYNAMIC

&IF "{&OPSYS}" = "WIN32":U AND "{&WINDOW-SYSTEM}" NE "TTY":U &THEN

CREATE CONTROL-FRAME CtrlFrame ASSIGN
       FRAME        = FRAME DEFAULT-FRAME:HANDLE
       ROW          = 1.24
       COLUMN       = 14
       HEIGHT       = 1.33
       WIDTH        = 5.6
       HIDDEN       = yes
       SENSITIVE    = yes.
      CtrlFrame:NAME = "CtrlFrame":U .
/* CtrlFrame OCXINFO:CREATE-CONTROL from: {F0B88A90-F5DA-11CF-B545-0020AF6ED35A} type: PSTimer */
      CtrlFrame:MOVE-BEFORE(bt-pausa:HANDLE IN FRAME DEFAULT-FRAME).

&ENDIF

&ANALYZE-RESUME /* End of _CREATE-DYNAMIC */


/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* Tetris */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* Tetris */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-novo
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-novo C-Win
ON CHOOSE OF bt-novo IN FRAME DEFAULT-FRAME /* New */
DO:
  RUN proc-ini.
  RUN sort-obj.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-pausa
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-pausa C-Win
ON CHOOSE OF bt-pausa IN FRAME DEFAULT-FRAME /* Pause */
DO:
  IF NOT wl_pausa THEN
    ASSIGN wl_pausa = YES
           bt-pausa:LABEL = "Resume".
  ELSE
    ASSIGN wl_pausa = NO
           bt-pausa:LABEL = "Pause".
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME CtrlFrame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CtrlFrame C-Win
PROCEDURE CtrlFrame.PSTimer.Tick .
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  None required for OCX.
  Notes:       
------------------------------------------------------------------------------*/
  DEF VAR wl_cnd AS LOG.
  DEF VAR wl_nomov AS LOG.
   
  IF wl_pausa THEN
    NEXT. 
  FOR EACH t-obj WHERE 
           tstate = "MOVE".
    RUN verif-pos (INPUT t-obj.tobj,
                   INPUT "DOWN").  
  END.
  wl_cnd = NO.
  FOR EACH t-obj WHERE 
           tstate = "MOVE".
    RUN move-obj (INPUT t-obj.tobj,
                  OUTPUT wl_nomov).
    IF wl_nomov THEN
      wl_cnd = YES.
  END.
  
  IF wl_cnd THEN 
  DO:
    FOR EACH t-obj WHERE 
             t-obj.tstate = "MOVE":
      ASSIGN t-obj.tstate = "END".   
      FIND t-pos WHERE 
           t-pos.tx = t-obj.tx AND 
           t-pos.ty = t-obj.ty NO-ERROR.
      IF NOT AVAIL t-pos THEN
      DO:
        CREATE t-pos.
        ASSIGN t-pos.tx = t-obj.tx 
               t-pos.ty = t-obj.ty.
      END.    
    END.    
    RUN verif-kill.
    DISPLAY (wi_killer / 10) @ fi-lines 
      WITH FRAME {&FRAME-NAME}.
    FIND FIRST t-pos WHERE 
               t-pos.ty = 45 AND 
              (t-pos.tx > 20 AND
               t-pos.tx < 130) NO-ERROR.
    IF AVAIL t-pos THEN
    DO:
      MESSAGE "GAVE OVER" VIEW-AS ALERT-BOX.
      RETURN.
    END.  
    FOR EACH t-obj WHERE 
             t-obj.tstate = "NEXT":
      RUN atu-col (INPUT t-obj.tobj).
    END.            
    RUN sort-obj.
  END.         
  
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_About
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_About C-Win
ON CHOOSE OF MENU-ITEM m_About /* About Tetris */
DO:
  RUN teabout.w.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Exit
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Exit C-Win
ON CHOOSE OF MENU-ITEM m_Exit /* Exit */
DO:
   RUN disable_UI.
   QUIT.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_New
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_New C-Win
ON CHOOSE OF MENU-ITEM m_New /* New */
DO:
  RUN proc-ini.
  RUN sort-obj.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
DO:
   RUN disable_UI.
   QUIT.
END.

ON CURSOR-UP ANYWHERE
DO:
  wi_giro = wi_giro + 1.
  IF wi_giro = (NUM-ENTRIES(wc_giro[wi_obj]) + 1)
    THEN wi_giro = 1.
  wi_cubo = 0.
  myx = 0.
  myy = 0.
  wl_out = NO.
  FOR EACH t-obj WHERE 
           tstate = "MOVE" BY t-obj.ty BY t-obj.tx:
    wi_cubo = wi_cubo + 1.       
    RUN verif-pos (INPUT t-obj.tobj,
                   INPUT "CHANGE").  
  END.
  IF wl_out THEN DO:
    IF wi_obj = 1 AND 
       myx = 30 THEN
      myx = 40.
    ELSE IF wi_obj = 1 OR 
       wi_obj = 6 THEN
      myx = 100.
    ELSE IF wi_obj = 3 THEN
      myx = 40.  
    ELSE IF wi_obj = 4 OR 
            wi_obj = 5 OR 
            wi_obj = 7 THEN
      myx = 110. 
    wi_cubo = 0.
    FOR EACH t-obj WHERE 
           tstate = "MOVE" BY t-obj.ty BY t-obj.tx:
    wi_cubo = wi_cubo + 1.       
    RUN verif-pos (INPUT t-obj.tobj,
                   INPUT "CHANGE").  
    END.
  END. 
  FOR EACH t-obj WHERE 
           tstate = "MOVE".
    RUN move-obj (INPUT t-obj.tobj,
                  OUTPUT ll).
  END.
  IF ll THEN
    wi_giro = wi_giro - 1.
END.
   
ON CURSOR-DOWN ANYWHERE
DO:
  FOR EACH t-obj WHERE 
           tstate = "MOVE".
    RUN verif-pos (INPUT t-obj.tobj,
                   INPUT "DOWN").  
  END.
  FOR EACH t-obj WHERE 
           tstate = "MOVE".
    RUN move-obj (INPUT t-obj.tobj,
                  OUTPUT ll).
  END.
END.

ON CURSOR-RIGHT ANYWHERE
DO:
  FOR EACH t-obj WHERE 
           tstate = "MOVE".
    RUN verif-pos (INPUT t-obj.tobj,
                   INPUT "RIGHT").  
  END.
  FOR EACH t-obj WHERE 
           tstate = "MOVE".
    RUN move-obj (INPUT t-obj.tobj,
                  OUTPUT ll).
  END.
END.  
ON CURSOR-LEFT ANYWHERE
DO:
  FOR EACH t-obj WHERE 
           tstate = "MOVE".
    RUN verif-pos (INPUT t-obj.tobj,
                   INPUT "LEFT").  
  END.
  FOR EACH t-obj WHERE 
           tstate = "MOVE".
    RUN move-obj (INPUT t-obj.tobj,
                  OUTPUT ll).
  END.
END.  
 

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  RUN proc-ini.
  RUN sort-obj.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE atu-col C-Win 
PROCEDURE atu-col :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEF INPUT PARAMETER pobj AS WIDGET-HANDLE.
  
  FIND t-obj WHERE 
       t-obj.tobj = pobj NO-ERROR.
  IF AVAIL t-obj THEN
    ASSIGN pobj:x = pobj:x - 70
           t-obj.tx = pobj:x
           t-obj.tstate = "MOVE".    
  
  

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE control_load C-Win _CONTROL-LOAD
PROCEDURE control_load :
/*------------------------------------------------------------------------------
  Purpose:     Load the OCXs    
  Parameters:  <none>
  Notes:       Here we load, initialize and make visible the 
               OCXs in the interface.                        
------------------------------------------------------------------------------*/

&IF "{&OPSYS}" = "WIN32":U AND "{&WINDOW-SYSTEM}" NE "TTY":U &THEN
DEFINE VARIABLE UIB_S    AS LOGICAL    NO-UNDO.
DEFINE VARIABLE OCXFile  AS CHARACTER  NO-UNDO.

OCXFile = SEARCH( "Tetris.wrx":U ).
IF OCXFile = ? THEN
  OCXFile = SEARCH(SUBSTRING(THIS-PROCEDURE:FILE-NAME, 1,
                     R-INDEX(THIS-PROCEDURE:FILE-NAME, ".":U), "CHARACTER":U) + "wrx":U).

IF OCXFile <> ? THEN
DO:
  ASSIGN
    chCtrlFrame = CtrlFrame:COM-HANDLE
    UIB_S = chCtrlFrame:LoadControls( OCXFile, "CtrlFrame":U)
  .
  RUN initialize-controls IN THIS-PROCEDURE NO-ERROR.
END.
ELSE MESSAGE "Tetris.wrx":U SKIP(1)
             "The binary control file could not be found. The controls cannot be loaded."
             VIEW-AS ALERT-BOX TITLE "Controls Not Loaded".

&ENDIF

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  RUN control_load.
  DISPLAY fi-lines 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE rc-1 bt-pausa bt-novo 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE move-obj C-Win 
PROCEDURE move-obj :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEF INPUT PARAMETER pobj  AS WIDGET-HANDLE.
  DEF OUTPUT PARAMETER pnomov AS LOG INITIAL NO.
   
  IF CAN-FIND(FIRST t-obj WHERE 
                    t-obj.tstate = "MOVE" AND
                    t-obj.tnomov = YES) THEN 
  DO:               
    pnomov = YES.
    RETURN.      
  END.    

  FIND t-obj WHERE 
       t-obj.tobj = pobj NO-ERROR.
  
  ASSIGN t-obj.tx = t-obj.ttox
         t-obj.ty = t-obj.ttoy
         pobj:x   = t-obj.ttox
         pobj:y   = t-obj.ttoy.
         
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE proc-ini C-Win 
PROCEDURE proc-ini :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  FOR EACH t-pos.
    DELETE t-pos.
  END.
  FOR EACH t-obj:
    IF VALID-HANDLE(t-obj.tobj) THEN
      DELETE WIDGET t-obj.tobj.
    DELETE t-obj.
  END.
  wi_killer = 0.
  wi_color = 0.
  rc-1:BGCOLOR IN FRAME {&FRAME-NAME}= wi_color.
  DISPLAY wi_killer @ fi-lines 
    WITH FRAME {&FRAME-NAME}.
  APPLY "ENTRY" TO bt-pausa.
  DO wi=45 TO 275 BY 10:
    CREATE t-pos.
    ASSIGN t-pos.tx = 20
           t-pos.ty = wi
           t-pos.tout = YES.
    CREATE t-pos.
    ASSIGN t-pos.tx = 130
           t-pos.ty = wi
           t-pos.tout = YES.
  END.
  DO wi=30 TO 120 BY 10:
    CREATE t-pos.
    ASSIGN t-pos.tx = wi
           t-pos.ty = 245
           t-pos.tout = YES.
  END.


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE repos C-Win 
PROCEDURE repos :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEF INPUT PARAMETER pobj AS WIDGET-HANDLE.

  FIND t-obj WHERE
       t-obj.tobj = pobj NO-ERROR.

  FIND t-pos WHERE 
       t-pos.tx = t-obj.tx AND 
       t-pos.ty = t-obj.ty NO-ERROR.
  IF AVAIL t-pos THEN
    DELETE t-pos.

  ASSIGN pobj:y = pobj:y + 10.
  
  IF AVAIL t-obj THEN
    ASSIGN t-obj.ty   = pobj:y
           t-obj.ttoy = pobj:y.
  
  FIND t-pos WHERE 
       t-pos.tx = t-obj.tx AND 
       t-pos.ty = t-obj.ty NO-ERROR.
  IF NOT AVAIL t-pos THEN
  DO:
    CREATE t-pos.
    ASSIGN t-pos.tx = t-obj.tx
           t-pos.ty = t-obj.ty.
  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE sort-obj C-Win 
PROCEDURE sort-obj :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  
  DEF VAR wr_x AS DEC INITIAL 70.
  DEF VAR wr_y AS DEC INITIAL 45.
  DEF VAR wh AS WIDGET-HANDLE.
  DEF VAR wc_xy AS CHAR.
  DEF VAR wi_obj2 AS INT.

  wi_giro = 1.
  wi_obj = RANDOM(1,7). 
  wi_obj2 = RANDOM(1,7).
   
  FIND FIRST t-obj WHERE 
             t-obj.tstate = "MOVE" NO-ERROR.
  IF NOT AVAIL t-obj THEN                 
  DO wi = 1 TO 24 BY 6:
    wc_xy = SUBSTR(ENTRY(wi_obj,wc_obj),wi,6).
    CREATE IMAGE wh 
    ASSIGN FRAME = rc-1:FRAME IN FRAME {&FRAME-NAME}  
               Y = wr_y + (( INT(SUBSTR(wc_xy,2,2)) - 1) * 10) 
               X = wr_x + (( INT(SUBSTR(wc_xy,5,2)) - 1) * 10) 
         VISIBLE = YES.   
         
    ASSIGN LL = wh:LOAD-IMAGE(ENTRY(wi_obj,wc_cor) + ".BMP"). 
    CREATE t-obj.
    ASSIGN t-obj.tobj   = wh
           t-obj.ttype  = wi_obj
           t-obj.tstate = "MOVE"
           t-obj.tx     = wh:x
           t-obj.ty     = wh:y.  
  END.
  ELSE wi_obj = t-obj.ttype.
  DO wi = 1 TO 24 BY 6:
    wc_xy = SUBSTR(ENTRY(wi_obj2,wc_obj),wi,6).
    CREATE IMAGE wh 
    ASSIGN FRAME = rc-1:FRAME IN FRAME {&FRAME-NAME}  
               Y = wr_y + (( INT(SUBSTR(wc_xy,2,2)) - 1) * 10)  
               X = wr_x + (( INT(SUBSTR(wc_xy,5,2)) - 1) * 10) + 70
         VISIBLE = YES.   
    ASSIGN LL = wh:LOAD-IMAGE(ENTRY(wi_obj2,wc_cor) + ".BMP"). 
    CREATE t-obj.
    ASSIGN t-obj.tobj   = wh
           t-obj.ttype  = wi_obj2
           t-obj.tstate = "NEXT"
           t-obj.tx     = wh:x
           t-obj.ty     = wh:y.  
  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE verif-kill C-Win 
PROCEDURE verif-kill :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEF VAR wi1 AS INT.
  DEF VAR wi2 AS INT.
  
  DEF BUFFER b-t-obj FOR t-obj.
  
  BL1:
  DO wi1=275 TO 45 BY -10:
    ll = YES.
    DO wi2 = 30 TO 120 BY 10:
      FIND t-obj WHERE 
           t-obj.ty = wi1 AND
           t-obj.tx = wi2 NO-ERROR.
      IF NOT AVAIL t-obj THEN
      DO:
        ll = NO.
        NEXT BL1.
      END.
    END.
    IF ll = YES THEN
    DO:
      FOR EACH b-t-obj WHERE
               b-t-obj.ty = wi1 AND 
               b-t-obj.tstate <> "NEXT":
        DELETE WIDGET b-t-obj.tobj.
        wi_killer = wi_killer + 1.
        IF wi_killer MODULO 500 = 0 THEN
        DO:
          wi_color = wi_color + 1.
          IF wi_color = 16 THEN
            wi_color = 0.
          rc-1:BGCOLOR IN FRAME {&FRAME-NAME}= wi_color.
        END.
        FIND t-pos WHERE 
             t-pos.tx = b-t-obj.tx AND
             t-pos.ty = b-t-obj.ty NO-ERROR.
        IF AVAIL t-pos THEN
          DELETE t-pos.   
        DELETE b-t-obj.            
      END.         
      FOR EACH b-t-obj WHERE
               b-t-obj.ty < wi1 AND 
               b-t-obj.tstate <> "NEXT":
        RUN repos (INPUT b-t-obj.tobj).       
      END.         
      wi1 = wi1 + 10.
    END.
  END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE verif-pos C-Win 
PROCEDURE verif-pos :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  DEF INPUT PARAMETER pobj  AS WIDGET-HANDLE.
  DEF INPUT PARAMETER ptype AS CHAR.
  
  DEF VAR wr_x     AS DEC.
  DEF VAR wr_y     AS DEC.
  DEF VAR wc_xy AS CHAR.
    
  ASSIGN wr_x = pobj:x
         wr_y = pobj:y.
    
  IF ptype = "DOWN" THEN
    ASSIGN wr_y = wr_y + 10.
  ELSE IF ptype = "RIGHT" THEN
    ASSIGN wr_x = wr_x + 10.
  ELSE IF ptype = "LEFT" THEN
    ASSIGN wr_x = wr_x - 10.    
  ELSE IF ptype = "CHANGE" THEN
  DO:
    IF myx = 0 THEN
       myx = wr_x.
    IF myy = 0 THEN
       myy = wr_y.
       
    wc_xy = ENTRY(wi_giro,wc_giro[wi_obj]).

    ASSIGN wr_y = myy + 
      (( INT(SUBSTR(wc_xy,((5 * wi_cubo + (wi_cubo - 1)) - 3),2)) - 1) * 10) 
           wr_x = myx + 
      (( INT(SUBSTR(wc_xy,((5 * wi_cubo + (wi_cubo - 1)) - 0),2)) - 1) * 10).

  END.

  FIND t-pos WHERE 
       t-pos.tx = wr_x AND 
       t-pos.ty = wr_y NO-ERROR.
  
  IF AVAIL t-pos AND ptype = "CHANGE" AND
   t-pos.tout = YES THEN
   wl_out = YES.
  FIND t-obj WHERE 
       t-obj.tobj = pobj NO-ERROR.
  IF AVAIL t-obj THEN
    ASSIGN t-obj.ttox   = wr_x
           t-obj.ttoy   = wr_y.
           t-obj.tnomov = AVAIL t-pos.  

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


