&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------

  File: memoria.w

  Description: Jogo da Memoria

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: Mauricio Guerrero

  Created: 12/12/2000 (In Home)

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

DEFINE TEMP-TABLE t-pos 
  FIELD tbutton AS CHAR
  FIELD thandle AS HANDLE
  FIELD timage  AS CHAR
  FIELD trandom AS INT
  FIELD tpos    AS INT
  FIELD tenable AS LOG INITIAL YES
  FIELD topen   AS LOG INITIAL NO
  FIELD torder  AS INT INITIAL 999999
  INDEX t-pos1  AS UNIQUE tbutton
  INDEX t-pos2            timage
  INDEX t-pos3            torder
  INDEX t-pos4  AS UNIQUE thandle.
  
DEFINE BUFFER b-t-pos FOR t-pos.
  
DEFINE VAR li AS INT.
DEFINE VAR ll AS LOG.
DEFINE VAR li-order AS INT.
DEFINE VAR ll-basico AS LOG INITIAL YES.  
  
DEFINE VAR lc-image AS CHAR EXTENT 30.

ASSIGN lc-image[01] = "cow.ico"
       lc-image[02] = "cow.ico"
       lc-image[03] = "lion.ico"
       lc-image[04] = "lion.ico"
       lc-image[05] = "monkey.ico"
       lc-image[06] = "monkey.ico"
       lc-image[07] = "piggy.ico"
       lc-image[08] = "piggy.ico"
       lc-image[09] = "snail.ico"
       lc-image[10] = "snail.ico"
       lc-image[11] = "flamingo.ico"
       lc-image[12] = "flamingo.ico"
       lc-image[13] = "bee.ico"
       lc-image[14] = "bee.ico"
       lc-image[15] = "bird.ico"
       lc-image[16] = "bird.ico"
       lc-image[17] = "cat.ico"
       lc-image[18] = "cat.ico"
       lc-image[19] = "dog.ico"
       lc-image[20] = "dog.ico"
       lc-image[21] = "duck.ico"
       lc-image[22] = "duck.ico"
       lc-image[23] = "ladybug.ico"
       lc-image[24] = "ladybug.ico"
       lc-image[25] = "frog.ico"
       lc-image[26] = "frog.ico"
       lc-image[27] = "bear.ico"
       lc-image[28] = "bear.ico"
       lc-image[29] = "seahorse.ico"
       lc-image[30] = "seahorse.ico".

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME DEFAULT-FRAME

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS bt-1 bt-2 bt-3 bt-4 bt-17 bt-18 bt-novo bt-5 ~
bt-6 bt-7 bt-8 bt-19 bt-20 bt-9 bt-10 bt-11 bt-12 bt-21 bt-22 bt-13 bt-14 ~
bt-15 bt-16 bt-23 bt-24 bt-25 bt-26 bt-27 bt-28 bt-29 bt-30 
&Scoped-Define DISPLAYED-OBJECTS fi-mov fi-record 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Menu Definitions                                                     */
DEFINE SUB-MENU m_Jogo 
       MENU-ITEM m_Novo         LABEL "New"           
       RULE
       MENU-ITEM m_Sair         LABEL "Exit"          .

DEFINE SUB-MENU m_nivel 
       MENU-ITEM m_basico       LABEL "Basic"         
       MENU-ITEM m_Avanado      LABEL "Avanced"       .

DEFINE SUB-MENU m_Ajuda 
       MENU-ITEM m_Sobre        LABEL "About Memory"  .

DEFINE MENU MENU-BAR-C-Win MENUBAR
       SUB-MENU  m_Jogo         LABEL "Game"          
       SUB-MENU  m_nivel        LABEL "Level"         
       SUB-MENU  m_Ajuda        LABEL "Help"          .


/* Definitions of the field level widgets                               */
DEFINE BUTTON bt-1 
     IMAGE-UP FILE "vazio":U
     LABEL "Button 1" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-10 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 10" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-11 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 11" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-12 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 12" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-13 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 13" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-14 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 14" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-15 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 15" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-16 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 16" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-17 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 17" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-18 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 18" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-19 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 19" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-2 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 2" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-20 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 20" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-21 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 21" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-22 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 22" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-23 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 23" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-24 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 24" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-25 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 25" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-26 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 26" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-27 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 27" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-28 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 28" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-29 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 29" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-3 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 3" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-30 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 30" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-4 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 4" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-5 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 5" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-6 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 6" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-7 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 7" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-8 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 8" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-9 
     IMAGE-UP FILE "vazio":U
     LABEL "bt 9" 
     SIZE 7 BY 1.67.

DEFINE BUTTON bt-novo 
     LABEL "New" 
     SIZE 15 BY 1.14.

DEFINE VARIABLE fi-mov AS INTEGER FORMAT "->,>>>,>>9":U INITIAL 0 
     LABEL "Moves" 
     VIEW-AS FILL-IN NATIVE 
     SIZE 15 BY 1 NO-UNDO.

DEFINE VARIABLE fi-record AS INTEGER FORMAT "->,>>>,>>9":U INITIAL 0 
     LABEL "Record" 
     VIEW-AS FILL-IN NATIVE 
     SIZE 15 BY 1 NO-UNDO.

DEFINE IMAGE im-1
     FILENAME "vazio2":U
     SIZE 7 BY 1.43.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     bt-1 AT ROW 1.24 COL 2
     bt-2 AT ROW 1.24 COL 9
     bt-3 AT ROW 1.24 COL 16
     bt-4 AT ROW 1.24 COL 23
     bt-17 AT ROW 1.24 COL 30
     bt-18 AT ROW 1.24 COL 37
     bt-novo AT ROW 1.71 COL 57
     bt-5 AT ROW 2.91 COL 2
     bt-6 AT ROW 2.91 COL 9
     bt-7 AT ROW 2.91 COL 16
     bt-8 AT ROW 2.91 COL 23
     bt-19 AT ROW 2.91 COL 30
     bt-20 AT ROW 2.91 COL 37
     fi-mov AT ROW 3.14 COL 55 COLON-ALIGNED
     fi-record AT ROW 4.33 COL 55 COLON-ALIGNED
     bt-9 AT ROW 4.57 COL 2
     bt-10 AT ROW 4.57 COL 9
     bt-11 AT ROW 4.57 COL 16
     bt-12 AT ROW 4.57 COL 23
     bt-21 AT ROW 4.57 COL 30
     bt-22 AT ROW 4.57 COL 37
     bt-13 AT ROW 6.24 COL 2
     bt-14 AT ROW 6.24 COL 9
     bt-15 AT ROW 6.24 COL 16
     bt-16 AT ROW 6.24 COL 23
     bt-23 AT ROW 6.24 COL 30
     bt-24 AT ROW 6.24 COL 37
     bt-25 AT ROW 7.91 COL 2
     bt-26 AT ROW 7.91 COL 9
     bt-27 AT ROW 7.91 COL 16
     bt-28 AT ROW 7.91 COL 23
     bt-29 AT ROW 7.91 COL 30
     bt-30 AT ROW 7.91 COL 37
     im-1 AT ROW 7.43 COL 56
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 72.8 BY 10.57.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "Memory Game"
         HEIGHT             = 10.57
         WIDTH              = 72.8
         MAX-HEIGHT         = 10.57
         MAX-WIDTH          = 72.8
         VIRTUAL-HEIGHT     = 10.57
         VIRTUAL-WIDTH      = 72.8
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.

ASSIGN {&WINDOW-NAME}:MENUBAR    = MENU MENU-BAR-C-Win:HANDLE.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME


/* ***************  Runtime Attributes and UIB Settings  ************** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
                                                                        */
ASSIGN 
       bt-17:HIDDEN IN FRAME DEFAULT-FRAME           = TRUE.

ASSIGN 
       bt-18:HIDDEN IN FRAME DEFAULT-FRAME           = TRUE.

ASSIGN 
       bt-19:HIDDEN IN FRAME DEFAULT-FRAME           = TRUE.

ASSIGN 
       bt-20:HIDDEN IN FRAME DEFAULT-FRAME           = TRUE.

ASSIGN 
       bt-21:HIDDEN IN FRAME DEFAULT-FRAME           = TRUE.

ASSIGN 
       bt-22:HIDDEN IN FRAME DEFAULT-FRAME           = TRUE.

ASSIGN 
       bt-23:HIDDEN IN FRAME DEFAULT-FRAME           = TRUE.

ASSIGN 
       bt-24:HIDDEN IN FRAME DEFAULT-FRAME           = TRUE.

ASSIGN 
       bt-25:HIDDEN IN FRAME DEFAULT-FRAME           = TRUE.

ASSIGN 
       bt-26:HIDDEN IN FRAME DEFAULT-FRAME           = TRUE.

ASSIGN 
       bt-27:HIDDEN IN FRAME DEFAULT-FRAME           = TRUE.

ASSIGN 
       bt-28:HIDDEN IN FRAME DEFAULT-FRAME           = TRUE.

ASSIGN 
       bt-29:HIDDEN IN FRAME DEFAULT-FRAME           = TRUE.

ASSIGN 
       bt-30:HIDDEN IN FRAME DEFAULT-FRAME           = TRUE.

/* SETTINGS FOR FILL-IN fi-mov IN FRAME DEFAULT-FRAME
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN fi-record IN FRAME DEFAULT-FRAME
   NO-ENABLE                                                            */
/* SETTINGS FOR IMAGE im-1 IN FRAME DEFAULT-FRAME
   NO-ENABLE                                                            */
ASSIGN 
       im-1:HIDDEN IN FRAME DEFAULT-FRAME           = TRUE.

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 




/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* Memory Game */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* Memory Game */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-1
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-1 C-Win
ON CHOOSE OF bt-1 IN FRAME DEFAULT-FRAME /* Button 1 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-10
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-10 C-Win
ON CHOOSE OF bt-10 IN FRAME DEFAULT-FRAME /* bt 10 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-11
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-11 C-Win
ON CHOOSE OF bt-11 IN FRAME DEFAULT-FRAME /* bt 11 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-12
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-12 C-Win
ON CHOOSE OF bt-12 IN FRAME DEFAULT-FRAME /* bt 12 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-13
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-13 C-Win
ON CHOOSE OF bt-13 IN FRAME DEFAULT-FRAME /* bt 13 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-14
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-14 C-Win
ON CHOOSE OF bt-14 IN FRAME DEFAULT-FRAME /* bt 14 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-15
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-15 C-Win
ON CHOOSE OF bt-15 IN FRAME DEFAULT-FRAME /* bt 15 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-16
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-16 C-Win
ON CHOOSE OF bt-16 IN FRAME DEFAULT-FRAME /* bt 16 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-17
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-17 C-Win
ON CHOOSE OF bt-17 IN FRAME DEFAULT-FRAME /* bt 17 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-18
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-18 C-Win
ON CHOOSE OF bt-18 IN FRAME DEFAULT-FRAME /* bt 18 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-19
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-19 C-Win
ON CHOOSE OF bt-19 IN FRAME DEFAULT-FRAME /* bt 19 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-2
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-2 C-Win
ON CHOOSE OF bt-2 IN FRAME DEFAULT-FRAME /* bt 2 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-20
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-20 C-Win
ON CHOOSE OF bt-20 IN FRAME DEFAULT-FRAME /* bt 20 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-21
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-21 C-Win
ON CHOOSE OF bt-21 IN FRAME DEFAULT-FRAME /* bt 21 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-22
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-22 C-Win
ON CHOOSE OF bt-22 IN FRAME DEFAULT-FRAME /* bt 22 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-23
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-23 C-Win
ON CHOOSE OF bt-23 IN FRAME DEFAULT-FRAME /* bt 23 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-24
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-24 C-Win
ON CHOOSE OF bt-24 IN FRAME DEFAULT-FRAME /* bt 24 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-25
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-25 C-Win
ON CHOOSE OF bt-25 IN FRAME DEFAULT-FRAME /* bt 25 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-26
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-26 C-Win
ON CHOOSE OF bt-26 IN FRAME DEFAULT-FRAME /* bt 26 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-27
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-27 C-Win
ON CHOOSE OF bt-27 IN FRAME DEFAULT-FRAME /* bt 27 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-28
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-28 C-Win
ON CHOOSE OF bt-28 IN FRAME DEFAULT-FRAME /* bt 28 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-29
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-29 C-Win
ON CHOOSE OF bt-29 IN FRAME DEFAULT-FRAME /* bt 29 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-3
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-3 C-Win
ON CHOOSE OF bt-3 IN FRAME DEFAULT-FRAME /* bt 3 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-30
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-30 C-Win
ON CHOOSE OF bt-30 IN FRAME DEFAULT-FRAME /* bt 30 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-4
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-4 C-Win
ON CHOOSE OF bt-4 IN FRAME DEFAULT-FRAME /* bt 4 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-5
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-5 C-Win
ON CHOOSE OF bt-5 IN FRAME DEFAULT-FRAME /* bt 5 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-6
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-6 C-Win
ON CHOOSE OF bt-6 IN FRAME DEFAULT-FRAME /* bt 6 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-7
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-7 C-Win
ON CHOOSE OF bt-7 IN FRAME DEFAULT-FRAME /* bt 7 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-8
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-8 C-Win
ON CHOOSE OF bt-8 IN FRAME DEFAULT-FRAME /* bt 8 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-9
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-9 C-Win
ON CHOOSE OF bt-9 IN FRAME DEFAULT-FRAME /* bt 9 */
DO:
  RUN acao.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME bt-novo
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL bt-novo C-Win
ON CHOOSE OF bt-novo IN FRAME DEFAULT-FRAME /* New */
DO:
  RUN sorteia.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Avanado
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Avanado C-Win
ON CHOOSE OF MENU-ITEM m_Avanado /* Avanced */
DO:
  IF ll-basico THEN
  DO:
    ll-basico = NO.
    RUN sorteia.
  END.  

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_basico
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_basico C-Win
ON CHOOSE OF MENU-ITEM m_basico /* Basic */
DO:
  IF NOT ll-basico THEN
  DO:
    ll-basico = YES.
    RUN sorteia.
  END.  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Novo
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Novo C-Win
ON CHOOSE OF MENU-ITEM m_Novo /* New */
DO:
  RUN sorteia.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Sair
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Sair C-Win
ON CHOOSE OF MENU-ITEM m_Sair /* Exit */
DO:
  APPLY "CLOSE" TO THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME m_Sobre
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL m_Sobre C-Win
ON CHOOSE OF MENU-ITEM m_Sobre /* About Memory */
DO:
  run sobre.w.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
DO:
   RUN disable_UI.
   QUIT.
END.   

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  RUN sorteia.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE acao C-Win 
PROCEDURE acao :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  ASSIGN li = 0.
  FOR EACH t-pos WHERE 
           t-pos.tenable AND 
           t-pos.topen:
    li = li + 1.
  END.     

  FIND t-pos WHERE 
       t-pos.tbutton = FOCUS:NAME NO-ERROR.
  IF AVAIL t-pos THEN
  DO:
    IF t-pos.tenable = NO THEN
      RETURN NO-APPLY.
    li-order = li-order + 1.
    fi-mov = li-order.
    DISPLAY fi-mov 
      WITH FRAME {&FRAME-NAME}.
    IF t-pos.topen THEN
    DO:
      RUN vira (INPUT t-pos.thandle).
      RUN limpa (INPUT t-pos.thandle).  
      ASSIGN t-pos.topen  = NO
             t-pos.torder = 999999.
    END.         
    ELSE 
    DO:
      IF li = 2 THEN
        RETURN NO-APPLY.
      RUN vira (INPUT t-pos.thandle).  
      RUN imagem (INPUT t-pos.thandle, 
                  INPUT t-pos.timage).                       
      ASSIGN t-pos.topen = YES
             t-pos.torder = li-order.
      FIND b-t-pos WHERE 
           b-t-pos.tenable AND 
           b-t-pos.topen AND
           b-t-pos.timage = t-pos.timage AND
           b-t-pos.tbutton  <> t-pos.tbutton NO-ERROR.
      IF AVAIL b-t-pos THEN
      DO:
        ASSIGN b-t-pos.tenable = NO
               t-pos.tenable   = NO.
      END. 
      ELSE DO:
        IF li = 1 THEN
        DO:
          READKEY PAUSE 1.
          RUN vira (INPUT t-pos.thandle).
          RUN limpa (INPUT t-pos.thandle).
          ASSIGN t-pos.topen  = NO
                 t-pos.torder = 999999.
          FOR EACH t-pos WHERE 
                   t-pos.topen AND 
                   t-pos.tenable:
            RUN vira (INPUT t-pos.thandle).       
            RUN limpa (INPUT t-pos.thandle).
            ASSIGN t-pos.topen  = NO
                   t-pos.torder = 999999.
                       
          END.               
        END.  
      END.
      li = 0.
      FOR EACH t-pos WHERE
               t-pos.tenable = NO:
        li = li + 1.       
      END.         
      IF li = (IF ll-basico THEN 16 ELSE 30) THEN
      DO:
        MESSAGE "CONGRATULATIONS" VIEW-AS ALERT-BOX.
        IF INT(fi-record:SCREEN-VALUE) = 0 OR 
          li-order < INT(fi-record:SCREEN-VALUE)
        THEN
        DO:
          IF li-order < INT(fi-record:SCREEN-VALUE) THEN
            MESSAGE "NEW RECORD" VIEW-AS ALERT-BOX.
            fi-record = li-order.
          DISPLAY fi-record 
            WITH FRAME {&FRAME-NAME}.
        END.    
        APPLY "ENTRY" TO bt-novo.
      END.
    END.     
  END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY fi-mov fi-record 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE bt-1 bt-2 bt-3 bt-4 bt-17 bt-18 bt-novo bt-5 bt-6 bt-7 bt-8 bt-19 
         bt-20 bt-9 bt-10 bt-11 bt-12 bt-21 bt-22 bt-13 bt-14 bt-15 bt-16 bt-23 
         bt-24 bt-25 bt-26 bt-27 bt-28 bt-29 bt-30 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE imagem C-Win 
PROCEDURE imagem :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEF INPUT PARAMETER myhandle AS HANDLE.
  DEF INPUT PARAMETER imagem AS CHAR.
  
  ll = myhandle:LOAD-IMAGE-UP(imagem).
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE limpa C-Win 
PROCEDURE limpa :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEF INPUT PARAMETER myhandle AS HANDLE.
  
  ll = myhandle:LOAD-IMAGE-UP("vazio.bmp").

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE sorteia C-Win 
PROCEDURE sorteia :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  
  ASSIGN ll = bt-1:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-2:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-3:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-4:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-5:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-6:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-7:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-8:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-9:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-10:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-11:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-12:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-13:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-14:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-15:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-16:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-17:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-18:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-19:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-20:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-21:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-22:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-23:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-24:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-25:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-26:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-27:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-28:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-29:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         ll = bt-30:LOAD-IMAGE-UP("vazio.bmp") IN FRAME {&FRAME-NAME}
         li-order = 0.
         
  IF ll-basico THEN
  DO:
    DISABLE bt-17 bt-18 bt-19 bt-20 bt-21 bt-22 bt-23
            bt-24 bt-25 bt-26 bt-27 bt-28 bt-29 bt-30.
    ASSIGN bt-17:HIDDEN = YES
           bt-18:HIDDEN = YES
           bt-19:HIDDEN = YES
           bt-20:HIDDEN = YES
           bt-21:HIDDEN = YES
           bt-22:HIDDEN = YES
           bt-23:HIDDEN = YES
           bt-24:HIDDEN = YES
           bt-25:HIDDEN = YES
           bt-26:HIDDEN = YES
           bt-27:HIDDEN = YES
           bt-28:HIDDEN = YES
           bt-29:HIDDEN = YES
           bt-30:HIDDEN = YES.
  END.
  ELSE 
  DO:
    ENABLE bt-17 bt-18 bt-19 bt-20 bt-21 bt-22 bt-23
           bt-24 bt-25 bt-26 bt-27 bt-28 bt-29 bt-30.
    ASSIGN bt-17:HIDDEN = NO
           bt-18:HIDDEN = NO
           bt-19:HIDDEN = NO
           bt-20:HIDDEN = NO
           bt-21:HIDDEN = NO
           bt-22:HIDDEN = NO
           bt-23:HIDDEN = NO
           bt-24:HIDDEN = NO
           bt-25:HIDDEN = NO
           bt-26:HIDDEN = NO
           bt-27:HIDDEN = NO
           bt-28:HIDDEN = NO
           bt-29:HIDDEN = NO
           bt-30:HIDDEN = NO. 
  END.
      
  FOR EACH t-pos:
    DELETE t-pos.
  END.
         
  DISPLAY 0 @ fi-mov 
    WITH FRAME {&FRAME-NAME}.
  DO li = 1 TO (IF ll-basico THEN 16 ELSE 30):
    FIND t-pos WHERE 
         t-pos.tbutton = "bt-" + STRING(li) NO-ERROR.
    IF NOT AVAIL t-pos THEN
    DO:
      CREATE t-pos.
      ASSIGN t-pos.tbutton = "bt-" + TRIM(STRING(li)).
    END.
    ASSIGN t-pos.trandom = RANDOM(1,TIME * 2)
           t-pos.topen   = NO
           t-pos.tenable = YES.
  END.
  
  li = 0.
  FOR EACH t-pos 
        BY t-pos.trandom:
    li = li + 1.
    t-pos.timage = lc-image[li].
  END.
  
  FOR EACH t-pos:
    IF t-pos.tbutton = "bt-1" THEN
      t-pos.thandle = bt-1:HANDLE.
    ELSE IF t-pos.tbutton = "bt-2" THEN
      t-pos.thandle = bt-2:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-3" THEN
      t-pos.thandle = bt-3:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-4" THEN
      t-pos.thandle = bt-4:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-5" THEN
      t-pos.thandle = bt-5:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-6" THEN
      t-pos.thandle = bt-6:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-7" THEN
      t-pos.thandle = bt-7:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-8" THEN
      t-pos.thandle = bt-8:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-9" THEN
      t-pos.thandle = bt-9:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-10" THEN
      t-pos.thandle = bt-10:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-11" THEN
      t-pos.thandle = bt-11:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-12" THEN
      t-pos.thandle = bt-12:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-13" THEN
      t-pos.thandle = bt-13:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-14" THEN
      t-pos.thandle = bt-14:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-15" THEN
      t-pos.thandle = bt-15:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-16" THEN
      t-pos.thandle = bt-16:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-17" THEN
      t-pos.thandle = bt-17:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-18" THEN
      t-pos.thandle = bt-18:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-19" THEN
      t-pos.thandle = bt-19:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-20" THEN
      t-pos.thandle = bt-20:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-21" THEN
      t-pos.thandle = bt-21:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-22" THEN
      t-pos.thandle = bt-22:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-23" THEN
      t-pos.thandle = bt-23:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-24" THEN
      t-pos.thandle = bt-24:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-25" THEN
      t-pos.thandle = bt-25:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-26" THEN
      t-pos.thandle = bt-26:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-27" THEN
      t-pos.thandle = bt-27:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-28" THEN
      t-pos.thandle = bt-28:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-29" THEN
      t-pos.thandle = bt-29:HANDLE.  
    ELSE IF t-pos.tbutton = "bt-30" THEN
      t-pos.thandle = bt-30:HANDLE.  
  END.
  
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE vira C-Win 
PROCEDURE vira :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER myhandle AS HANDLE.

  DEFINE VARIABLE li AS INT.
  
  DO WITH FRAME {&FRAME-NAME}:
    im-1:COLUMN = myhandle:COLUMN.
    im-1:ROW    = myhandle:ROW.
    myhandle:HIDDEN = YES.
    im-1:HIDDEN = NO.
    DO li=1 TO 1000:
    END.
    im-1:HIDDEN = YES.
    myhandle:HIDDEN = NO.
  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


